import Reference from './Reference';
import type { ISchema } from './util/types';
export interface ConditionBuilder<T extends ISchema<any, any>> {
    (this: T, value: any, schema: T): ISchema<any, any> | void;
    (v1: any, v2: any, schema: T): ISchema<any, any> | void;
    (v1: any, v2: any, v3: any, schema: T): ISchema<any, any> | void;
    (v1: any, v2: any, v3: any, v4: any, schema: T): ISchema<any, any> | void;
}
export declare type ConditionConfig<T extends ISchema<any>> = {
    is: any | ((...values: any[]) => boolean);
    then?: (schema: T) => ISchema<any>;
    otherwise?: (schema: T) => ISchema<any>;
};
export declare type ConditionOptions<T extends ISchema<any, any>> = ConditionBuilder<T> | ConditionConfig<T>;
export declare type ResolveOptions<TContext = any> = {
    value?: any;
    parent?: any;
    context?: TContext;
};
declare class Condition<T extends ISchema<any, any> = ISchema<any, any>> {
    refs: Reference[];
    fn: ConditionBuilder<T>;
    constructor(refs: Reference[], options: ConditionOptions<T>);
    resolve(base: T, options: ResolveOptions): ISchema<any, import("./types").AnyObject, any, any> | T;
}
export default Condition;
