import BaseSchema from './schema';
import type { AnyObject, Maybe, Message } from './types';
import type { Defined, Flags, NotNull, SetFlag, Thunk, ToggleDefault } from './util/types';
export declare function create(): BooleanSchema;
export declare function create<T extends boolean, TContext = AnyObject>(): BooleanSchema<T | undefined, TContext>;
export declare namespace create {
    var prototype: BooleanSchema<any, any, any, any>;
}
export default class BooleanSchema<TType extends Maybe<boolean> = boolean | undefined, TContext = AnyObject, TDefault = undefined, TFlags extends Flags = ''> extends BaseSchema<TType, TContext, TDefault, TFlags> {
    constructor();
    protected _typeCheck(v: any): v is NonNullable<TType>;
    isTrue(message?: Message<any> | undefined): BooleanSchema<TType | true, TContext, TFlags>;
    isFalse(message?: Message<any> | undefined): BooleanSchema<TType | false, TContext, TFlags>;
    default<D extends Maybe<TType>>(def: Thunk<D>): BooleanSchema<TType, TContext, D, ToggleDefault<TFlags, D>>;
    defined(msg?: Message): BooleanSchema<Defined<TType>, TContext, TDefault, TFlags>;
    optional(): BooleanSchema<TType | undefined, TContext, TDefault, TFlags>;
    required(msg?: Message): BooleanSchema<NonNullable<TType>, TContext, TDefault, TFlags>;
    notRequired(): BooleanSchema<Maybe<TType>, TContext, TDefault, TFlags>;
    nullable(): BooleanSchema<TType | null, TContext, TDefault, TFlags>;
    nonNullable(msg?: Message): BooleanSchema<NotNull<TType>, TContext, TDefault, TFlags>;
    strip(): BooleanSchema<TType, TContext, TDefault, SetFlag<TFlags, 's'>>;
}
